- [首页](/zh/README.md)
- 快速开始
    - 使用Configuration API
        - [使用Apollo配置中心](zh/start/configuration/start-apollo.md)
        - [使用Etcd配置中心](zh/start/configuration/start.md)
    - [使用State API](zh/start/state/start.md)
    - [使用Pub/Sub API](zh/start/pubsub/start.md)
    - [使用分布式锁 API](zh/start/lock/start.md)
    - [使用Sequencer API生成分布式自增id](zh/start/sequencer/start.md)
    - 进行RPC调用
        - [Hello World](zh/start/rpc/helloworld.md)
        - [Dubbo JSON RPC](zh/start/rpc/dubbo_json_rpc.md)
    - 集成 Istio
        - [作为 Istio 的数据面](zh/start/istio/start.md)
    - 在四层网络进行流量干预
        - [Dump TCP 流量](zh/start/network_filter/tcpcopy.md)
    - 在七层网络进行流量干预
        - [方法级别限流](zh/start/stream_filter/flow_control.md)
    - [健康检查、查询运行时元数据](zh/start/actuator/start.md)
    - [trace管理](zh/start/trace/trace.md)
    - [OSS访问文件](zh/start/file/start.md)
    - [将业务逻辑通过 WASM 下沉进sidecar](zh/start/wasm/start.md)
    - [基于 WASM 跟 Runtime 实现的 Faas 模型](zh/start/faas/start.md)
- 用户手册
    - 功能介绍
        - [File API](zh/building_blocks/file/file.md)
        - [Configuration API](zh/building_blocks/configuration/reference.md)
        - [Actuator API](zh/building_blocks/actuator/actuator.md)
        - [State API](zh/building_blocks/state/reference.md)
        - [Sequencer API](zh/building_blocks/sequencer/reference.md)
        - [Distributed Lock API](zh/building_blocks/lock/reference.md)
        - [Pub/Sub API](zh/building_blocks/pubsub/reference.md)
        - [Configuration API](zh/building_blocks/configuration/reference.md)
        - [RPC API](zh/building_blocks/rpc/reference.md)
    - [grpc API 文档](https://github.com/mosn/layotto/blob/main/docs/en/api_reference/api_reference_v1.md)
    - SDK文档    
        - [go sdk](zh/sdk_reference/go/start.md)
        - [java sdk](https://github.com/mosn/layotto/blob/main/sdk/java-sdk/README-zh.md)
        - [.net sdk](https://github.com/layotto/dotnet-sdk)
        - [js sdk](https://github.com/layotto/js-sdk)
    - [配置文档](zh/configuration/overview.md)
    - [组件文档](zh/component_specs/overview.md)
        - [State](zh/component_specs/state/common.md)
            - [Redis](zh/component_specs/state/redis.md)
            - [其他组件](zh/component_specs/state/others.md)
        - [Pub/Sub](zh/component_specs/pubsub/common.md)
            - [Redis](zh/component_specs/pubsub/redis.md)
            - [其他组件](zh/component_specs/pubsub/others.md)
        - [Distributed Lock](zh/component_specs/lock/common.md)
            - [Redis](zh/component_specs/lock/redis.md)
            - [Etcd](zh/component_specs/lock/etcd.md)
            - [Zookeeper](zh/component_specs/lock/zookeeper.md)
            - [Consul](zh/component_specs/lock/consul.md)
        - Configuration
            - [Etcd](zh/component_specs/configuration/etcd.md)
            - [Apollo](zh/component_specs/configuration/apollo.md)
        - [File](zh/component_specs/file/common.md)
            - [OSS](zh/component_specs/file/oss.md)
        - [Sequencer](zh/component_specs/sequencer/common.md)
            - [Etcd](zh/component_specs/sequencer/etcd.md)
            - [Redis](zh/component_specs/sequencer/redis.md)
            - [Zookeeper](zh/component_specs/sequencer/zookeeper.md)
- 设计文档
    - [Actuator设计文档](zh/design/actuator/actuator-design-doc.md)
    - [gRPC框架设计文档](zh/design/actuator/grpc-design-doc.md)
    - [Configuration API with Apollo](zh/design/configuration/configuration-api-with-apollo.md)
    - [Pub/Sub API以及与dapr component的兼容性](zh/design/pubsub/pubsub-api-and-compability-with-dapr-component.md)
    - [RPC设计文档](zh/design/rpc/rpc设计文档.md)
    - [分布式锁API设计文档](zh/design/lock/lock-api-design.md)    
    - [Sequencer API设计文档](zh/design/sequencer/design.md)
    - [file API设计文档](zh/design/file/file-design.md)
    - [FaaS 设计文档](zh/design/faas/faas-poc-design.md)
- 贡献指南
    - [新手攻略：从零开始成为 Layotto 贡献者](zh/development/start-from-zero.md)
    - [文档贡献指南](zh/development/contributing-doc.md)
    - [组件开发指南](zh/development/developing-component.md)
    - 想要修改proto文件或API定义？
        - [新增API时的开发规范](zh/development/developing-api.md)
        - [proto文件注释规范](zh/api_reference/comment_spec_of_proto.md)
        - [如何基于proto文件生成接口文档](zh/api_reference/how_to_generate_api_doc.md)  
    - [Layotto贡献者指南](zh/development/CONTRIBUTING.md) 
    - [解释一下Layotto的github workflow](zh/development/explanation-for-github-workflow.md)
    - [待解决的问题](zh/development/problems-to-solve.md)
- 社区
    - [SOFAStack & MOSN 社区角色说明](zh/community/governance.md)
    - [Layotto社区晋升规则](zh/community/promote.md)
    - [Layotto社区成员](zh/community/people.md)
- 博客
    - [蚂蚁云原生应用运行时的探索和实践 - ArchSummit 上海](zh/blog/exploration-and-practice-of-antcloud-native-application-runtime-archsummit-shanghai.md)
    - [MOSN子项目Layotto：开启服务网格+应用运行时新篇章](zh/blog/mosn-subproject-layotto-opening-a-new-chapter-in-service-grid-application-runtime/index.md)
- 演讲视频
  - [Service Mesh落地之后：为 sidecar 注入灵魂](zh/video/inject-soul-into-sidecar.md)
  - [MOSN子项目Layotto：开启服务网格+应用运行时新篇章](zh/video/a-new-chapter-in-service-mesh-application-runtime.md)
